/* Copyright (c) 2006, NIF File Format Library and Tools
All rights reserved.  Please see niflib.h for license. */

//-----------------------------------NOTICE----------------------------------//
// Some of this file is automatically filled in by a Python script.  Only    //
// add custom code in the designated areas or it will be overwritten during  //
// the next update.                                                          //
//-----------------------------------NOTICE----------------------------------//

#ifndef _BSSHADERPPLIGHTINGPROPERTY_H_
#define _BSSHADERPPLIGHTINGPROPERTY_H_

//--BEGIN FILE HEAD CUSTOM CODE--//

//--END CUSTOM CODE--//

#include "BSShaderLightingProperty.h"

// Include structures
#include "../Ref.h"
namespace Niflib {

// Forward define of referenced NIF objects
class BSShaderTextureSet;
class BSShaderPPLightingProperty;
typedef Ref<BSShaderPPLightingProperty> BSShaderPPLightingPropertyRef;

/*! Bethesda-specific Shade node. */
class BSShaderPPLightingProperty : public BSShaderLightingProperty {
public:
	/*! Constructor */
	NIFLIB_API BSShaderPPLightingProperty();

	/*! Destructor */
	NIFLIB_API virtual ~BSShaderPPLightingProperty();

	/*!
	 * A constant value which uniquly identifies objects of this type.
	 */
	NIFLIB_API static const Type TYPE;

	/*!
	 * A factory function used during file reading to create an instance of this type of object.
	 * \return A pointer to a newly allocated instance of this type of object.
	 */
	NIFLIB_API static NiObject * Create();

	/*!
	 * Summarizes the information contained in this object in English.
	 * \param[in] verbose Determines whether or not detailed information about large areas of data will be printed out.
	 * \return A string containing a summary of the information within the object in English.  This is the function that Niflyze calls to generate its analysis, so the output is the same.
	 */
	NIFLIB_API virtual string asString( bool verbose = false ) const;

	/*!
	 * Used to determine the type of a particular instance of this object.
	 * \return The type constant for the actual type of the object.
	 */
	NIFLIB_API virtual const Type & GetType() const;

	/***Begin Example Naive Implementation****

	// Texture Set
	// \return The current value.
	Ref<BSShaderTextureSet > GetTextureSet() const;

	// Texture Set
	// \param[in] value The new value.
	void SetTextureSet( Ref<BSShaderTextureSet > value );

	// Rate of texture movement for refraction shader.
	// \return The current value.
	int GetRefractionPeriod() const;

	// Rate of texture movement for refraction shader.
	// \param[in] value The new value.
	void SetRefractionPeriod( int value );

	// Glow color and alpha
	// \return The current value.
	Color4 GetEmissiveColor() const;

	// Glow color and alpha
	// \param[in] value The new value.
	void SetEmissiveColor( const Color4 & value );

	****End Example Naive Implementation***/

	//--BEGIN MISC CUSTOM CODE--//

	// Texture Set
	// \return The current value.
	Ref<BSShaderTextureSet > GetTextureSet() const;

	// Texture Set
	// \param[in] value The new value.
	void SetTextureSet( Ref<BSShaderTextureSet > value );

	//--END CUSTOM CODE--//
protected:
	/*! Texture Set */
	Ref<BSShaderTextureSet > textureSet;
	/*! Unknown */
	float unknownFloat2;
	/*! Rate of texture movement for refraction shader. */
	int refractionPeriod;
	/*! Unknown */
	float unknownFloat4;
	/*! Unknown */
	float unknownFloat5;
	/*! Glow color and alpha */
	Color4 emissiveColor;
public:
	/*! NIFLIB_HIDDEN function.  For internal use only. */
	NIFLIB_HIDDEN virtual void Read( istream& in, list<unsigned int> & link_stack, const NifInfo & info );
	/*! NIFLIB_HIDDEN function.  For internal use only. */
	NIFLIB_HIDDEN virtual void Write( ostream& out, const map<NiObjectRef,unsigned int> & link_map, list<NiObject *> & missing_link_stack, const NifInfo & info ) const;
	/*! NIFLIB_HIDDEN function.  For internal use only. */
	NIFLIB_HIDDEN virtual void FixLinks( const map<unsigned int,NiObjectRef> & objects, list<unsigned int> & link_stack, list<NiObjectRef> & missing_link_stack, const NifInfo & info );
	/*! NIFLIB_HIDDEN function.  For internal use only. */
	NIFLIB_HIDDEN virtual list<NiObjectRef> GetRefs() const;
	/*! NIFLIB_HIDDEN function.  For internal use only. */
	NIFLIB_HIDDEN virtual list<NiObject *> GetPtrs() const;
};

//--BEGIN FILE FOOT CUSTOM CODE--//

//--END CUSTOM CODE--//

} //End Niflib namespace
#endif
