/* Copyright (c) 2006, NIF File Format Library and Tools
All rights reserved.  Please see niflib.h for license. */

//-----------------------------------NOTICE----------------------------------//
// Some of this file is automatically filled in by a Python script.  Only    //
// add custom code in the designated areas or it will be overwritten during  //
// the next update.                                                          //
//-----------------------------------NOTICE----------------------------------//

#ifndef _FXRADIOBUTTON_H_
#define _FXRADIOBUTTON_H_

//--BEGIN FILE HEAD CUSTOM CODE--//
//--END CUSTOM CODE--//

#include "FxWidget.h"
namespace Niflib {

class FxRadioButton;
typedef Ref<FxRadioButton> FxRadioButtonRef;

/*! Unknown. */
class FxRadioButton : public FxWidget {
public:
	/*! Constructor */
	NIFLIB_API FxRadioButton();

	/*! Destructor */
	NIFLIB_API virtual ~FxRadioButton();

	/*!
	 * A constant value which uniquly identifies objects of this type.
	 */
	NIFLIB_API static const Type TYPE;

	/*!
	 * A factory function used during file reading to create an instance of this type of object.
	 * \return A pointer to a newly allocated instance of this type of object.
	 */
	NIFLIB_API static NiObject * Create();

	/*!
	 * Summarizes the information contained in this object in English.
	 * \param[in] verbose Determines whether or not detailed information about large areas of data will be printed out.
	 * \return A string containing a summary of the information within the object in English.  This is the function that Niflyze calls to generate its analysis, so the output is the same.
	 */
	NIFLIB_API virtual string asString( bool verbose = false ) const;

	/*!
	 * Used to determine the type of a particular instance of this object.
	 * \return The type constant for the actual type of the object.
	 */
	NIFLIB_API virtual const Type & GetType() const;

	/***Begin Example Naive Implementation****

	// Unknown pointers to other buttons.  Maybe other buttons in a group so they can
	// be switch off if this one is switched on?
	// \return The current value.
	vector<FxRadioButton * > GetButtons() const;

	// Unknown pointers to other buttons.  Maybe other buttons in a group so they can
	// be switch off if this one is switched on?
	// \param[in] value The new value.
	void SetButtons( const vector<FxRadioButton * >& value );

	****End Example Naive Implementation***/

	//--BEGIN MISC CUSTOM CODE--//
	//--END CUSTOM CODE--//
protected:
	/*! Unknown. */
	unsigned int unknownInt1;
	/*! Unknown. */
	unsigned int unknownInt2;
	/*! Unknown. */
	unsigned int unknownInt3;
	/*! Number of unknown links. */
	mutable unsigned int numButtons;
	/*!
	 * Unknown pointers to other buttons.  Maybe other buttons in a group so they can
	 * be switch off if this one is switched on?
	 */
	vector<FxRadioButton * > buttons;
public:
	/*! NIFLIB_HIDDEN function.  For internal use only. */
	NIFLIB_HIDDEN virtual void Read( istream& in, list<unsigned int> & link_stack, const NifInfo & info );
	/*! NIFLIB_HIDDEN function.  For internal use only. */
	NIFLIB_HIDDEN virtual void Write( ostream& out, const map<NiObjectRef,unsigned int> & link_map, list<NiObject *> & missing_link_stack, const NifInfo & info ) const;
	/*! NIFLIB_HIDDEN function.  For internal use only. */
	NIFLIB_HIDDEN virtual void FixLinks( const map<unsigned int,NiObjectRef> & objects, list<unsigned int> & link_stack, list<NiObjectRef> & missing_link_stack, const NifInfo & info );
	/*! NIFLIB_HIDDEN function.  For internal use only. */
	NIFLIB_HIDDEN virtual list<NiObjectRef> GetRefs() const;
	/*! NIFLIB_HIDDEN function.  For internal use only. */
	NIFLIB_HIDDEN virtual list<NiObject *> GetPtrs() const;
};

//--BEGIN FILE FOOT CUSTOM CODE--//
//--END CUSTOM CODE--//

} //End Niflib namespace
#endif
