/* Copyright (c) 2006, NIF File Format Library and Tools
All rights reserved.  Please see niflib.h for license. */

//-----------------------------------NOTICE----------------------------------//
// Some of this file is automatically filled in by a Python script.  Only    //
// add custom code in the designated areas or it will be overwritten during  //
// the next update.                                                          //
//-----------------------------------NOTICE----------------------------------//

#ifndef _NIBEZIERTRIANGLE4_H_
#define _NIBEZIERTRIANGLE4_H_

//--BEGIN FILE HEAD CUSTOM CODE--//

//--END CUSTOM CODE--//

#include "NiObject.h"
namespace Niflib {

class NiBezierTriangle4;
typedef Ref<NiBezierTriangle4> NiBezierTriangle4Ref;

/*! Sub data of NiBezierMesh */
class NiBezierTriangle4 : public NiObject {
public:
	/*! Constructor */
	NIFLIB_API NiBezierTriangle4();

	/*! Destructor */
	NIFLIB_API virtual ~NiBezierTriangle4();

	/*!
	 * A constant value which uniquly identifies objects of this type.
	 */
	NIFLIB_API static const Type TYPE;

	/*!
	 * A factory function used during file reading to create an instance of this type of object.
	 * \return A pointer to a newly allocated instance of this type of object.
	 */
	NIFLIB_API static NiObject * Create();

	/*!
	 * Summarizes the information contained in this object in English.
	 * \param[in] verbose Determines whether or not detailed information about large areas of data will be printed out.
	 * \return A string containing a summary of the information within the object in English.  This is the function that Niflyze calls to generate its analysis, so the output is the same.
	 */
	NIFLIB_API virtual string asString( bool verbose = false ) const;

	/*!
	 * Used to determine the type of a particular instance of this object.
	 * \return The type constant for the actual type of the object.
	 */
	NIFLIB_API virtual const Type & GetType() const;

	/***Begin Example Naive Implementation****

	// unknown
	// \return The current value.
	Matrix33 GetMatrix() const;

	// unknown
	// \param[in] value The new value.
	void SetMatrix( const Matrix33 & value );

	// unknown
	// \return The current value.
	Vector3 GetVector1() const;

	// unknown
	// \param[in] value The new value.
	void SetVector1( const Vector3 & value );

	// unknown
	// \return The current value.
	Vector3 GetVector2() const;

	// unknown
	// \param[in] value The new value.
	void SetVector2( const Vector3 & value );

	****End Example Naive Implementation***/

	//--BEGIN MISC CUSTOM CODE--//

	//--END CUSTOM CODE--//
protected:
	/*! unknown */
	array<6,unsigned int > unknown1;
	/*! unknown */
	unsigned short unknown2;
	/*! unknown */
	Matrix33 matrix;
	/*! unknown */
	Vector3 vector1;
	/*! unknown */
	Vector3 vector2;
	/*! unknown */
	array<4,short > unknown3;
	/*! unknown */
	byte unknown4;
	/*! unknown */
	unsigned int unknown5;
	/*! unknown */
	array<24,short > unknown6;
public:
	/*! NIFLIB_HIDDEN function.  For internal use only. */
	NIFLIB_HIDDEN virtual void Read( istream& in, list<unsigned int> & link_stack, const NifInfo & info );
	/*! NIFLIB_HIDDEN function.  For internal use only. */
	NIFLIB_HIDDEN virtual void Write( ostream& out, const map<NiObjectRef,unsigned int> & link_map, list<NiObject *> & missing_link_stack, const NifInfo & info ) const;
	/*! NIFLIB_HIDDEN function.  For internal use only. */
	NIFLIB_HIDDEN virtual void FixLinks( const map<unsigned int,NiObjectRef> & objects, list<unsigned int> & link_stack, list<NiObjectRef> & missing_link_stack, const NifInfo & info );
	/*! NIFLIB_HIDDEN function.  For internal use only. */
	NIFLIB_HIDDEN virtual list<NiObjectRef> GetRefs() const;
	/*! NIFLIB_HIDDEN function.  For internal use only. */
	NIFLIB_HIDDEN virtual list<NiObject *> GetPtrs() const;
};

//--BEGIN FILE FOOT CUSTOM CODE--//

//--END CUSTOM CODE--//

} //End Niflib namespace
#endif
