/* Copyright (c) 2006, NIF File Format Library and Tools
All rights reserved.  Please see niflib.h for license. */

//-----------------------------------NOTICE----------------------------------//
// Some of this file is automatically filled in by a Python script.  Only    //
// add custom code in the designated areas or it will be overwritten during  //
// the next update.                                                          //
//-----------------------------------NOTICE----------------------------------//

#ifndef _BHKBREAKABLECONSTRAINT_H_
#define _BHKBREAKABLECONSTRAINT_H_

//--BEGIN FILE HEAD CUSTOM CODE--//

//--END CUSTOM CODE--//

#include "bhkConstraint.h"
namespace Niflib {

// Forward define of referenced NIF objects
class bhkEntity;
class bhkBreakableConstraint;
typedef Ref<bhkBreakableConstraint> bhkBreakableConstraintRef;

/*! Bethesda-Specific node. */
class bhkBreakableConstraint : public bhkConstraint {
public:
	/*! Constructor */
	NIFLIB_API bhkBreakableConstraint();

	/*! Destructor */
	NIFLIB_API virtual ~bhkBreakableConstraint();

	/*!
	 * A constant value which uniquly identifies objects of this type.
	 */
	NIFLIB_API static const Type TYPE;

	/*!
	 * A factory function used during file reading to create an instance of this type of object.
	 * \return A pointer to a newly allocated instance of this type of object.
	 */
	NIFLIB_API static NiObject * Create();

	/*!
	 * Summarizes the information contained in this object in English.
	 * \param[in] verbose Determines whether or not detailed information about large areas of data will be printed out.
	 * \return A string containing a summary of the information within the object in English.  This is the function that Niflyze calls to generate its analysis, so the output is the same.
	 */
	NIFLIB_API virtual string asString( bool verbose = false ) const;

	/*!
	 * Used to determine the type of a particular instance of this object.
	 * \return The type constant for the actual type of the object.
	 */
	NIFLIB_API virtual const Type & GetType() const;

	/***Begin Example Naive Implementation****

	// The entities affected by this constraint.
	// \return The current value.
	vector<bhkEntity * > GetEntities2() const;

	// The entities affected by this constraint.
	// \param[in] value The new value.
	void SetEntities2( const vector<bhkEntity * >& value );

	// Usually 1. Higher values indicate higher priority of this constraint?
	// \return The current value.
	unsigned int GetPriority2() const;

	// Usually 1. Higher values indicate higher priority of this constraint?
	// \param[in] value The new value.
	void SetPriority2( unsigned int value );

	// Unknown
	// \return The current value.
	Vector3 GetPosition() const;

	// Unknown
	// \param[in] value The new value.
	void SetPosition( const Vector3 & value );

	// Unknown
	// \return The current value.
	Vector3 GetRotation() const;

	// Unknown
	// \param[in] value The new value.
	void SetRotation( const Vector3 & value );

	// Unknown
	// \return The current value.
	float GetThreshold() const;

	// Unknown
	// \param[in] value The new value.
	void SetThreshold( float value );

	// Unknown
	// \return The current value.
	byte GetRemoveIfBroken() const;

	// Unknown
	// \param[in] value The new value.
	void SetRemoveIfBroken( byte value );

	****End Example Naive Implementation***/

	//--BEGIN MISC CUSTOM CODE--//

	//--END CUSTOM CODE--//
protected:
	/*!  */
	array<41,int > unknownInts1;
	/*! Unknown */
	short unknownShort1;
	/*! A count or flag? */
	unsigned int unknownInt1;
	/*! Number of bodies affected by this constraint. */
	mutable unsigned int numEntities2;
	/*! The entities affected by this constraint. */
	vector<bhkEntity * > entities2;
	/*! Usually 1. Higher values indicate higher priority of this constraint? */
	unsigned int priority2;
	/*! Unknown */
	unsigned int unknownInt2;
	/*! Unknown */
	Vector3 position;
	/*! Unknown */
	Vector3 rotation;
	/*! Unknown */
	unsigned int unknownInt3;
	/*! Unknown */
	float threshold;
	/*! Unknown */
	float unknownFloat1;
	/*! Unknown */
	byte removeIfBroken;
public:
	/*! NIFLIB_HIDDEN function.  For internal use only. */
	NIFLIB_HIDDEN virtual void Read( istream& in, list<unsigned int> & link_stack, const NifInfo & info );
	/*! NIFLIB_HIDDEN function.  For internal use only. */
	NIFLIB_HIDDEN virtual void Write( ostream& out, const map<NiObjectRef,unsigned int> & link_map, list<NiObject *> & missing_link_stack, const NifInfo & info ) const;
	/*! NIFLIB_HIDDEN function.  For internal use only. */
	NIFLIB_HIDDEN virtual void FixLinks( const map<unsigned int,NiObjectRef> & objects, list<unsigned int> & link_stack, list<NiObjectRef> & missing_link_stack, const NifInfo & info );
	/*! NIFLIB_HIDDEN function.  For internal use only. */
	NIFLIB_HIDDEN virtual list<NiObjectRef> GetRefs() const;
	/*! NIFLIB_HIDDEN function.  For internal use only. */
	NIFLIB_HIDDEN virtual list<NiObject *> GetPtrs() const;
};

//--BEGIN FILE FOOT CUSTOM CODE--//

//--END CUSTOM CODE--//

} //End Niflib namespace
#endif
