/* Copyright (c) 2006, NIF File Format Library and Tools
All rights reserved.  Please see niflib.h for license. */

//-----------------------------------NOTICE----------------------------------//
// Some of this file is automatically filled in by a Python script.  Only    //
// add custom code in the designated areas or it will be overwritten during  //
// the next update.                                                          //
//-----------------------------------NOTICE----------------------------------//

//--BEGIN FILE HEAD CUSTOM CODE--//

//--END CUSTOM CODE--//

#include "../../include/FixLink.h"
#include "../../include/ObjectRegistry.h"
#include "../../include/NIF_IO.h"
#include "../../include/obj/BSLagBoneController.h"
using namespace Niflib;

//Definition of TYPE constant
const Type BSLagBoneController::TYPE("BSLagBoneController", &NiTimeController::TYPE );

BSLagBoneController::BSLagBoneController() : linearVelocity(0.0f), linearRotation(0.0f), maximumDistance(0.0f) {
	//--BEGIN CONSTRUCTOR CUSTOM CODE--//

	//--END CUSTOM CODE--//
}

BSLagBoneController::~BSLagBoneController() {
	//--BEGIN DESTRUCTOR CUSTOM CODE--//

	//--END CUSTOM CODE--//
}

const Type & BSLagBoneController::GetType() const {
	return TYPE;
}

NiObject * BSLagBoneController::Create() {
	return new BSLagBoneController;
}

void BSLagBoneController::Read( istream& in, list<unsigned int> & link_stack, const NifInfo & info ) {
	//--BEGIN PRE-READ CUSTOM CODE--//

	//--END CUSTOM CODE--//

	NiTimeController::Read( in, link_stack, info );
	NifStream( linearVelocity, in, info );
	NifStream( linearRotation, in, info );
	NifStream( maximumDistance, in, info );

	//--BEGIN POST-READ CUSTOM CODE--//

	//--END CUSTOM CODE--//
}

void BSLagBoneController::Write( ostream& out, const map<NiObjectRef,unsigned int> & link_map, list<NiObject *> & missing_link_stack, const NifInfo & info ) const {
	//--BEGIN PRE-WRITE CUSTOM CODE--//

	//--END CUSTOM CODE--//

	NiTimeController::Write( out, link_map, missing_link_stack, info );
	NifStream( linearVelocity, out, info );
	NifStream( linearRotation, out, info );
	NifStream( maximumDistance, out, info );

	//--BEGIN POST-WRITE CUSTOM CODE--//

	//--END CUSTOM CODE--//
}

std::string BSLagBoneController::asString( bool verbose ) const {
	//--BEGIN PRE-STRING CUSTOM CODE--//

	//--END CUSTOM CODE--//

	stringstream out;
	out << NiTimeController::asString();
	out << "  Linear Velocity:  " << linearVelocity << endl;
	out << "  Linear Rotation:  " << linearRotation << endl;
	out << "  Maximum Distance:  " << maximumDistance << endl;
	return out.str();

	//--BEGIN POST-STRING CUSTOM CODE--//

	//--END CUSTOM CODE--//
}

void BSLagBoneController::FixLinks( const map<unsigned int,NiObjectRef> & objects, list<unsigned int> & link_stack, list<NiObjectRef> & missing_link_stack, const NifInfo & info ) {
	//--BEGIN PRE-FIXLINKS CUSTOM CODE--//

	//--END CUSTOM CODE--//

	NiTimeController::FixLinks( objects, link_stack, missing_link_stack, info );

	//--BEGIN POST-FIXLINKS CUSTOM CODE--//

	//--END CUSTOM CODE--//
}

std::list<NiObjectRef> BSLagBoneController::GetRefs() const {
	list<Ref<NiObject> > refs;
	refs = NiTimeController::GetRefs();
	return refs;
}

std::list<NiObject *> BSLagBoneController::GetPtrs() const {
	list<NiObject *> ptrs;
	ptrs = NiTimeController::GetPtrs();
	return ptrs;
}

/***Begin Example Naive Implementation****

float BSLagBoneController::GetLinearVelocity() const {
	return linearVelocity;
}

void BSLagBoneController::SetLinearVelocity( float value ) {
	linearVelocity = value;
}

float BSLagBoneController::GetLinearRotation() const {
	return linearRotation;
}

void BSLagBoneController::SetLinearRotation( float value ) {
	linearRotation = value;
}

float BSLagBoneController::GetMaximumDistance() const {
	return maximumDistance;
}

void BSLagBoneController::SetMaximumDistance( float value ) {
	maximumDistance = value;
}

****End Example Naive Implementation***/

//--BEGIN MISC CUSTOM CODE--//

//--END CUSTOM CODE--//
