/* Copyright (c) 2006, NIF File Format Library and Tools
All rights reserved.  Please see niflib.h for license. */

//-----------------------------------NOTICE----------------------------------//
// Some of this file is automatically filled in by a Python script.  Only    //
// add custom code in the designated areas or it will be overwritten during  //
// the next update.                                                          //
//-----------------------------------NOTICE----------------------------------//

//--BEGIN FILE HEAD CUSTOM CODE--//

//--END CUSTOM CODE--//

#include "../../include/FixLink.h"
#include "../../include/ObjectRegistry.h"
#include "../../include/NIF_IO.h"
#include "../../include/obj/NiPSysFieldModifier.h"
#include "../../include/obj/NiAVObject.h"
using namespace Niflib;

//Definition of TYPE constant
const Type NiPSysFieldModifier::TYPE("NiPSysFieldModifier", &NiPSysModifier::TYPE );

NiPSysFieldModifier::NiPSysFieldModifier() : fieldObject(NULL), magnitude(0.0f), attenuation(0.0f), useMaxDistance(false), maxDistance(0.0f) {
	//--BEGIN CONSTRUCTOR CUSTOM CODE--//

	//--END CUSTOM CODE--//
}

NiPSysFieldModifier::~NiPSysFieldModifier() {
	//--BEGIN DESTRUCTOR CUSTOM CODE--//

	//--END CUSTOM CODE--//
}

const Type & NiPSysFieldModifier::GetType() const {
	return TYPE;
}

NiObject * NiPSysFieldModifier::Create() {
	return new NiPSysFieldModifier;
}

void NiPSysFieldModifier::Read( istream& in, list<unsigned int> & link_stack, const NifInfo & info ) {
	//--BEGIN PRE-READ CUSTOM CODE--//

	//--END CUSTOM CODE--//

	unsigned int block_num;
	NiPSysModifier::Read( in, link_stack, info );
	NifStream( block_num, in, info );
	link_stack.push_back( block_num );
	NifStream( magnitude, in, info );
	NifStream( attenuation, in, info );
	NifStream( useMaxDistance, in, info );
	NifStream( maxDistance, in, info );

	//--BEGIN POST-READ CUSTOM CODE--//

	//--END CUSTOM CODE--//
}

void NiPSysFieldModifier::Write( ostream& out, const map<NiObjectRef,unsigned int> & link_map, list<NiObject *> & missing_link_stack, const NifInfo & info ) const {
	//--BEGIN PRE-WRITE CUSTOM CODE--//

	//--END CUSTOM CODE--//

	NiPSysModifier::Write( out, link_map, missing_link_stack, info );
	if ( info.version < VER_3_3_0_13 ) {
		WritePtr32( &(*fieldObject), out );
	} else {
		if ( fieldObject != NULL ) {
			map<NiObjectRef,unsigned int>::const_iterator it = link_map.find( StaticCast<NiObject>(fieldObject) );
			if (it != link_map.end()) {
				NifStream( it->second, out, info );
				missing_link_stack.push_back( NULL );
			} else {
				NifStream( 0xFFFFFFFF, out, info );
				missing_link_stack.push_back( fieldObject );
			}
		} else {
			NifStream( 0xFFFFFFFF, out, info );
			missing_link_stack.push_back( NULL );
		}
	}
	NifStream( magnitude, out, info );
	NifStream( attenuation, out, info );
	NifStream( useMaxDistance, out, info );
	NifStream( maxDistance, out, info );

	//--BEGIN POST-WRITE CUSTOM CODE--//

	//--END CUSTOM CODE--//
}

std::string NiPSysFieldModifier::asString( bool verbose ) const {
	//--BEGIN PRE-STRING CUSTOM CODE--//

	//--END CUSTOM CODE--//

	stringstream out;
	out << NiPSysModifier::asString();
	out << "  Field Object:  " << fieldObject << endl;
	out << "  Magnitude:  " << magnitude << endl;
	out << "  Attenuation:  " << attenuation << endl;
	out << "  Use Max Distance:  " << useMaxDistance << endl;
	out << "  Max Distance:  " << maxDistance << endl;
	return out.str();

	//--BEGIN POST-STRING CUSTOM CODE--//

	//--END CUSTOM CODE--//
}

void NiPSysFieldModifier::FixLinks( const map<unsigned int,NiObjectRef> & objects, list<unsigned int> & link_stack, list<NiObjectRef> & missing_link_stack, const NifInfo & info ) {
	//--BEGIN PRE-FIXLINKS CUSTOM CODE--//

	//--END CUSTOM CODE--//

	NiPSysModifier::FixLinks( objects, link_stack, missing_link_stack, info );
	fieldObject = FixLink<NiAVObject>( objects, link_stack, missing_link_stack, info );

	//--BEGIN POST-FIXLINKS CUSTOM CODE--//

	//--END CUSTOM CODE--//
}

std::list<NiObjectRef> NiPSysFieldModifier::GetRefs() const {
	list<Ref<NiObject> > refs;
	refs = NiPSysModifier::GetRefs();
	if ( fieldObject != NULL )
		refs.push_back(StaticCast<NiObject>(fieldObject));
	return refs;
}

std::list<NiObject *> NiPSysFieldModifier::GetPtrs() const {
	list<NiObject *> ptrs;
	ptrs = NiPSysModifier::GetPtrs();
	return ptrs;
}

/***Begin Example Naive Implementation****

Ref<NiAVObject > NiPSysFieldModifier::GetFieldObject() const {
	return fieldObject;
}

void NiPSysFieldModifier::SetFieldObject( Ref<NiAVObject > value ) {
	fieldObject = value;
}

float NiPSysFieldModifier::GetMagnitude() const {
	return magnitude;
}

void NiPSysFieldModifier::SetMagnitude( float value ) {
	magnitude = value;
}

float NiPSysFieldModifier::GetAttenuation() const {
	return attenuation;
}

void NiPSysFieldModifier::SetAttenuation( float value ) {
	attenuation = value;
}

bool NiPSysFieldModifier::GetUseMaxDistance() const {
	return useMaxDistance;
}

void NiPSysFieldModifier::SetUseMaxDistance( bool value ) {
	useMaxDistance = value;
}

float NiPSysFieldModifier::GetMaxDistance() const {
	return maxDistance;
}

void NiPSysFieldModifier::SetMaxDistance( float value ) {
	maxDistance = value;
}

****End Example Naive Implementation***/

//--BEGIN MISC CUSTOM CODE--//

//--END CUSTOM CODE--//
